using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace YourNameSpace
{
    public enum GridGroupingCategoryCategory
    {
        ThisWeek = 1,
        LastWeek = 2,
        ThisMonth = 3,
        LastMonth = 4,
        Older = 5
    }

    public static class GridGroupingHelper
    {
        public static class GridGroupingHelper_Format
        {
            public static string ColumnLabelByDateGroup(int category)
            {
                string label = string.Empty;
                switch (category)
                {
                    case 1:
                        label = "ThisWeek";
                        break;
                    case 2:
                        label = "LastWeek";
                        break;
                    case 3:
                        label = "ThisMonth";
                        break;
                    case 4:
                        label = "LastMonth";
                        break;
                    case 5:
                        label = "Older";
                        break;
                }
                return label;
            }
        }
        
        public class GridGroupingHelper_Categorizer : Syncfusion.Grouping.IGroupByColumnCategorizer
        {
            //defines a group and returns a group category
            public static int GetCategory(DateTime date)
            {
                long numberOfDays = 0;
                long numberOfWeeks = 0;
                long numberOfMonths = 0;
                int category = 0;

                //HERE I'M USING A NOTHER HELPER CLASS THAT CALCULATES THE DATE DIFFERENCE
                numberOfDays = DateTimeHelper.DateDiff(DateTimeHelper.DateInterval.Day, date, DateTime.Now);
                numberOfWeeks = DateTimeHelper.DateDiff(DateTimeHelper.DateInterval.Week, date, DateTime.Now);
                numberOfMonths = DateTimeHelper.DateDiff(DateTimeHelper.DateInterval.Month, date, DateTime.Now);

                if (numberOfDays <= 7)
                    category = Convert.ToInt32(GridGroupingCategoryCategory.ThisWeek);
                else if (numberOfDays > 7 && numberOfWeeks < 2)
                    category = Convert.ToInt32(GridGroupingCategoryCategory.LastWeek);
                else if (numberOfWeeks >= 2 && numberOfMonths < 1)
                    category = Convert.ToInt32(GridGroupingCategoryCategory.ThisMonth);
                else if (numberOfMonths >= 1 && numberOfMonths < 2)
                    category = Convert.ToInt32(GridGroupingCategoryCategory.LastMonth);
                else if (numberOfMonths >= 2)
                    category = Convert.ToInt32(GridGroupingCategoryCategory.Older);
                return category;
            }

            public object GetGroupByCategoryKey(SortColumnDescriptor column, bool isForeignKey, Record record)
            {
                return GetCategory(DateTime.Parse(record.GetValue(column).ToString()));
            }

            public int CompareCategoryKey(SortColumnDescriptor column, bool isForeignKey, object category, Record record)
            {
                return GetCategory(DateTime.Parse(record.GetValue(column).ToString())) - (int)category;
            }
        }

        public class GridGroupingHelper_Comparer : IComparer
        {
            #region IComparer Members

            public int Compare(object x, object y)
            {
                if (x == null)
                    return -1;
                else if (y == null)
                    return 100;
                else
                {
                    int i = int.Parse(x.ToString());
                    int j = int.Parse(y.ToString());
                    return i - j;
                }
            }

            #endregion
        }
    }
}
